package ru.ulstu.is.sbapp.calculator.domain;
import org.springframework.stereotype.Component;

import java.time.LocalDate;
import java.time.format.DateTimeFormatter;


@Component(value="date")
public class DateCalculator implements Calculator<LocalDate> {

    @Override
    public LocalDate Sum(LocalDate first, LocalDate second) {
        return first.plusYears(second.getYear()).
                plusMonths(second.getMonthValue()).plusDays(second.getDayOfMonth());
    }

    @Override
    public LocalDate Minus(LocalDate first, LocalDate second) {
        return first.minusYears(second.getYear()).
                minusMonths(second.getMonthValue()).minusDays(second.getDayOfMonth());
    }

    @Override
    public LocalDate Reverse(LocalDate first, LocalDate second) {

        DateTimeFormatter formatter = DateTimeFormatter.ofPattern("dd/MM/yyyy");
        String formattedFirst = first.format(formatter);
        return LocalDate.parse(formattedFirst, formatter);
    }

    @Override
    public LocalDate Comparison(LocalDate first, LocalDate second) {
        int comparisonResult = first.compareTo(second);

        if (comparisonResult < 0)
            return second;
        else return first;
    }
}
