package ru.ulstu.is.sbapp.calculator.service;

import org.springframework.context.ApplicationContext;
import org.springframework.stereotype.Service;
import ru.ulstu.is.sbapp.calculator.domain.Calculator;
import ru.ulstu.is.sbapp.calculator.domain.DateCalculator;
import ru.ulstu.is.sbapp.calculator.domain.StringCalculator;

import java.text.SimpleDateFormat;
import java.time.LocalDate;
import java.time.format.DateTimeFormatter;

@Service
public class CalculatorService {
    private final ApplicationContext _applicationContext;

    public CalculatorService(ApplicationContext applicationContext) {
        this._applicationContext = applicationContext;
    }

    public String Sum(Object first, Object second, String type) {
        final Calculator speaker = (Calculator) _applicationContext.getBean(type);


        if (speaker instanceof StringCalculator)
            return String.format("%s", speaker.Sum(first, second));

        else if (speaker instanceof DateCalculator)
                return String.format("%s", (speaker.Sum(LocalDate.parse(first.toString()), LocalDate.parse(second.toString()))));

        else return String.format("%s", speaker.Sum(Integer.parseInt(first.toString()), Integer.parseInt(second.toString())));

    }

    public String Ras(Object first, Object second, String type) {
        final Calculator speaker = (Calculator) _applicationContext.getBean(type);
        if (speaker instanceof StringCalculator)
            return String.format("%s", speaker.Minus(first,second));

        else if (speaker instanceof DateCalculator)
            return String.format("%s", (speaker.Minus(LocalDate.parse(first.toString()), LocalDate.parse(second.toString()))));

        else
            return String.format("%s", speaker.Minus(Integer.parseInt(first.toString()),Integer.parseInt(second.toString())));
    }
    public String Rev(Object first, Object second, String type) {
        final Calculator speaker = (Calculator) _applicationContext.getBean(type);
        if (speaker instanceof StringCalculator)
            return String.format("%s", speaker.Reverse(first,second));

        else if (speaker instanceof DateCalculator)
            return String.format("%s", (speaker.Reverse(LocalDate.parse(first.toString()), LocalDate.parse(second.toString()))));

        else return String.format("%s", speaker.Reverse(Integer.parseInt(first.toString()),Integer.parseInt(second.toString())));

    }
    public String Com(Object first, Object second, String type) {
        final Calculator speaker = (Calculator) _applicationContext.getBean(type);
        if (speaker instanceof StringCalculator)
            return String.format("%s", speaker.Comparison(first,second));

        else if (speaker instanceof DateCalculator)
            return String.format("%s", (speaker.Comparison(LocalDate.parse(first.toString()), LocalDate.parse(second.toString()))));

        else return String.format("%s", speaker.Comparison(Integer.parseInt(first.toString()), Integer.parseInt(second.toString())));
    }
}
